/**
 * Copyright (c) 2007-2012 EBM WebSourcing, 2012-2013 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see <http://www.gnu.org/licenses/>
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.se.quartz;

import javax.jbi.messaging.MessageExchange.Role;

import org.ow2.petals.commons.log.Level;
import org.ow2.petals.component.framework.api.message.Exchange;
import org.ow2.petals.component.framework.listener.AbstractJBIListener;
import org.ow2.petals.component.framework.logger.ConsumeFlowStepEndLogData;

/**
 * @author Adrien LOUIS - EBM WebSourcing
 * @author Vincent Zurczak - EBM WebSourcing
 */
public class QuartzJBIListener extends AbstractJBIListener {

    /*
     * (non-Javadoc)
     * 
     * @see org.ow2.petals.component.framework.listener.AbstractJBIListener
     * #onJBIMessage(org.ow2.petals.component.framework.api.message.Exchange)
     */
    @Override
    public boolean onJBIMessage(Exchange exchange) {
        if (exchange.isActiveStatus()) {
            // Cannot be a request from a consumer, nor a response from
            // another
            // MEP than InOnly.
            // It can only be only an error due to the configured CDK
            // filter.
            if (this.getLogger().isLoggable(Level.INFO)) {
                String msg = exchange.getExchangeId()
                        + " encountered a minor problem. The Quartz component does not accept request from consumers.";
                this.getLogger().info(msg);
            }

        } else {
            if (Role.CONSUMER.equals(exchange.getRole())) {
                this.getLogger()
                        .log(Level.MONIT,
                                "",
                                new ConsumeFlowStepEndLogData(exchange.getFlowAttributes()
                                        .getFlowInstanceId(), exchange.getFlowAttributes()
                                        .getFlowStepId()));
            }
        }
        return true;
    }
}
